## org.apache.http.impl.client
Class TargetAuthenticationStrategy

    java.lang.Object
      org.apache.http.impl.client.TargetAuthenticationStrategy

All Implemented Interfaces:
  AuthenticationStrategy

    @Immutable
    public class TargetAuthenticationStrategy

extends Object

Default `AuthenticationStrategy` implementation for proxy host authentication.

Since:
  4.2

Constructor Summary
`TargetAuthenticationStrategy()`

Method Summary
`void` `authFailed(HttpHost authhost, AuthScheme authScheme, HttpContext context)` Callback invoked in case of unsuccessful authentication.
`void` `authSucceeded(HttpHost authhost, AuthScheme authScheme, HttpContext context)` Callback invoked in case of successful authentication.
`Map<String,Header>` `getChallenges(HttpHost authhost, HttpResponse response, HttpContext context)` Extracts from the given HTTP response a collection of authentication challenges, each of which represents an authentication scheme supported by the authentication host.
`boolean` `isAuthenticationRequested(HttpHost authhost, HttpResponse response, HttpContext context)` Determines if the given HTTP response response represents an authentication challenge that was sent back as a result of authentication failure.
`protected boolean` `isCachable(AuthScheme authScheme)`
`Queue<AuthOption>` `select(Map<String,Header> challenges, HttpHost authhost, HttpResponse response, HttpContext context)` Selects one authentication challenge out of all available and creates and generates `AuthOption` instance capable of processing that challenge.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TargetAuthenticationStrategy

    public TargetAuthenticationStrategy()

Method Detail

### isAuthenticationRequested

    public boolean isAuthenticationRequested(HttpHost authhost,
                                             HttpResponse response,
                                             HttpContext context)

  Description copied from interface: `AuthenticationStrategy`
  Determines if the given HTTP response response represents an authentication challenge that was sent back as a result of authentication failure.

  Specified by:
    `isAuthenticationRequested` in interface `AuthenticationStrategy`
  Parameters:
    `authhost` - authentication host.
    `response` - HTTP response.
    `context` - HTTP context.
  Returns:
    `true` if user authentication is required, `false` otherwise.

### getChallenges

    public Map<String,Header> getChallenges(HttpHost authhost,
                                            HttpResponse response,
                                            HttpContext context)
                                     throws MalformedChallengeException

  Description copied from interface: `AuthenticationStrategy`
  Extracts from the given HTTP response a collection of authentication challenges, each of which represents an authentication scheme supported by the authentication host.

  Specified by:
    `getChallenges` in interface `AuthenticationStrategy`
  Parameters:
    `authhost` - authentication host.
    `response` - HTTP response.
    `context` - HTTP context.
  Returns:
    a collection of challenges keyed by names of corresponding authentication schemes.
  Throws:
    `MalformedChallengeException` - if one of the authentication challenges is not valid or malformed.

### select

    public Queue<AuthOption> select(Map<String,Header> challenges,
                                    HttpHost authhost,
                                    HttpResponse response,
                                    HttpContext context)
                             throws MalformedChallengeException

  Description copied from interface: `AuthenticationStrategy`
  Selects one authentication challenge out of all available and creates and generates `AuthOption` instance capable of processing that challenge.

  Specified by:
    `select` in interface `AuthenticationStrategy`
  Parameters:
    `challenges` - collection of challenges.
    `authhost` - authentication host.
    `response` - HTTP response.
    `context` - HTTP context.
  Returns:
    authentication auth schemes that can be used for authentication. Can be empty.
  Throws:
    `MalformedChallengeException` - if one of the authentication challenges is not valid or malformed.

### authSucceeded

    public void authSucceeded(HttpHost authhost,
                              AuthScheme authScheme,
                              HttpContext context)

  Description copied from interface: `AuthenticationStrategy`
  Callback invoked in case of successful authentication.

  Specified by:
    `authSucceeded` in interface `AuthenticationStrategy`
  Parameters:
    `authhost` - authentication host.
    `authScheme` - authentication scheme used.
    `context` - HTTP context.

### isCachable

    protected boolean isCachable(AuthScheme authScheme)

### authFailed

    public void authFailed(HttpHost authhost,
                           AuthScheme authScheme,
                           HttpContext context)

  Description copied from interface: `AuthenticationStrategy`
  Callback invoked in case of unsuccessful authentication.

  Specified by:
    `authFailed` in interface `AuthenticationStrategy`
  Parameters:
    `authhost` - authentication host.
    `authScheme` - authentication scheme used.
    `context` - HTTP context.

Copyright © 1999-2013 The Apache Software Foundation. All Rights Reserved.